package com.zt.plat.module.contractorder.service.purchaseorder;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlPageReqVO;
import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlRespVO;
import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlSaveReqVO;
import com.zt.plat.module.contractorder.dal.dataobject.purchaseorder.PrchOrdDtlDO;
import com.zt.plat.module.contractorder.dal.mysql.purchaseorder.PrchOrdDtlMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;



import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.contractorder.enums.purchaseorder.ErrorCodeConstants.PRCH_ORD_DTL_NOT_EXISTS;


/**
 * 采购订单明细 Service 实现类
 *
 * @author 后台管理-1
 */
@Service
@Validated
@Slf4j
public class PrchOrdDtlServiceImpl implements PrchOrdDtlService {

    @Resource
    private PrchOrdDtlMapper prchOrdDtlMapper;

    @Override
    public PrchOrdDtlRespVO createPrchOrdDtl(PrchOrdDtlSaveReqVO createReqVO) {
        // 插入
        PrchOrdDtlDO prchOrdDtl = BeanUtils.toBean(createReqVO, PrchOrdDtlDO.class);
        prchOrdDtlMapper.insert(prchOrdDtl);
        // 返回
        return BeanUtils.toBean(prchOrdDtl, PrchOrdDtlRespVO.class);
    }

    @Override
    public void updatePrchOrdDtl(PrchOrdDtlSaveReqVO updateReqVO) {
        // 校验存在
        validatePrchOrdDtlExists(updateReqVO.getId());
        // 更新
        PrchOrdDtlDO updateObj = BeanUtils.toBean(updateReqVO, PrchOrdDtlDO.class);
        prchOrdDtlMapper.updateById(updateObj);
    }

    @Override
    public void deletePrchOrdDtl(Long id) {
        // 校验存在
        validatePrchOrdDtlExists(id);
        // 删除
        prchOrdDtlMapper.deleteById(id);
    }

    @Override
        public void deletePrchOrdDtlListByIds(List<Long> ids) {
        // 校验存在
        validatePrchOrdDtlExists(ids);
        // 删除
        prchOrdDtlMapper.deleteByIds(ids);
        }

    private void validatePrchOrdDtlExists(List<Long> ids) {
        List<PrchOrdDtlDO> list = prchOrdDtlMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(PRCH_ORD_DTL_NOT_EXISTS);
        }
    }

    private void validatePrchOrdDtlExists(Long id) {
        if (prchOrdDtlMapper.selectById(id) == null) {
            throw exception(PRCH_ORD_DTL_NOT_EXISTS);
        }
    }

    @Override
    public PrchOrdDtlDO getPrchOrdDtl(Long id) {
        return prchOrdDtlMapper.selectById(id);
    }

    @Override
    public PageResult<PrchOrdDtlDO> getPrchOrdDtlPage(PrchOrdDtlPageReqVO pageReqVO) {
        return prchOrdDtlMapper.selectPage(pageReqVO);
    }

    @Override
    public List<PrchOrdDtlRespVO> batchCreatePrchOrdDtl(List<PrchOrdDtlSaveReqVO> createReqVOS) {
        List<PrchOrdDtlDO> prchOrdDtlDOS = BeanUtils.toBean(createReqVOS, PrchOrdDtlDO.class);
        prchOrdDtlMapper.insertBatch(prchOrdDtlDOS);
        log.info("批量创建采购订单明细成功,工插入【{}】条数据", prchOrdDtlDOS.size());
        return BeanUtils.toBean(prchOrdDtlDOS, PrchOrdDtlRespVO.class);
    }

    @Override
    public void deletePrchOrdDtlListByOrdIds(List<Long> ordIds) {
        //通过订单组件查询订单明细
        List<PrchOrdDtlDO> prchOrdDtlDOS = prchOrdDtlMapper.selectList(new LambdaQueryWrapper<>(PrchOrdDtlDO.class).in(PrchOrdDtlDO::getOrdId, ordIds));
        //删除订单明细
        deletePrchOrdDtlListByIds(convertList(prchOrdDtlDOS, PrchOrdDtlDO::getId));
    }

    @Override
    public List<PrchOrdDtlDO> getDetailsByOrderId(Long ordId) {

        return prchOrdDtlMapper.selectList(new LambdaQueryWrapper<>(PrchOrdDtlDO.class).eq(PrchOrdDtlDO::getOrdId, ordId));
    }

}
